function [result, success] = compute_shape_space(...
  distances, numdims, explained_variance_threshold, save_filename)

%grj 9/22/13 - force to minimum of 2 dimensions

  % [result, success] = compute_shape_space(...
  %   distances, numdims, explained_variance_threshold, save_filename)
  %
  % Given a distance matrix of a set of points, computes positions for those points using multidimensional scaling (y2) (the space in which those points live is called a shape space), its convex hull (convex_hull), and the Delaunay tessellation (tes) of those points.
  %
  % If explained_variance_threshold is an array with two elements, the second is the maximum allowable dimensionality.
  
  %error('Implementation yet unfinished below this line!')
  
  result = struct();
  result.y2 = [];
  result.convex_hull = [];
  result.tes = [];
  result.numdims = [];
  
  y2 = [];     
  convex_hull = [];
  tes = [];    
  
  success = false;
  % Check if work has been done
  [can_start, final_name, final_exists, tmpfile] = chunk_start(save_filename);
  
%   if (~can_start)
%     stack = dbstack();
%     % warning('Skipping "%s" at line %d in file %s.', save_filename, stack(1).line, stack(1).file)
%     fprintf('compute_shape_space: Skipping "%s" at line %d in file %s.\n', save_filename, stack(1).line, stack(1).file)
%     if final_exists
%       load([save_filename '.mat'])
%       success = true;
%     else
%       %error('Cannot continue, serial 1 being computed elsewhere.')
%       error('  Being computed elsewhere.')
%     end
  if ~can_start && ~final_exists
    error('  Being computed elsewhere.')
  else
    
    % keyboard
    
    [y, e] = cmdscale( distances );
    % e

    % Determine shape space dimensionality using positive eigenvalues
    % (too bad some of the negative ones can be large):
    explained_variances = [];
    if numdims == 0
      explained_variances = cumsum(e .* (e >= 0));
      explained_variances = explained_variances ./ explained_variances(end);
      sufficient_dimensionalities = ...
          find(explained_variances >= ...
               explained_variance_threshold(1)); 
      numdims = sufficient_dimensionalities(1);
      if length(explained_variance_threshold) > 1
        numdims = min(numdims, explained_variance_threshold(2));
      end
    end
    if numdims > size(y, 2)
      warning(['numdims = ', num2str(numdims), ' > size(y, 2) = ', num2str(size(y, 2))])
      numdims = size(y, 2);
    end
    
    if numdims == 1
        numdims = 2;
    end
    
    y2 = y(:,1:numdims);

    convex_hull = convhulln( y2 );
    %crashes:
    %convex_hull = convhulln( y2, {'Qt','Qx', 'T1'} );
    tes = delaunayn(y2);

    save([save_filename '.mat'], 'y2', 'convex_hull', 'tes', 'numdims', 'explained_variances');
    %%%%%%%%%%%%%%%%

    % Save work
    chunk_finish(tmpfile); 
  end

  result.y2 = y2;
  result.convex_hull = convex_hull;
  result.tes = tes;
  result.numdims = numdims;
  result.explained_variances = explained_variances;
  
  success = true;
